def truncate(string, limit=1000):
    if len(string) > limit:
        return string[:limit-20]+'...'+string[-17:]
    else:
        return string



def maybe_unicode_safe(ob, *args):
    if isinstance(ob, unicode) or ob is None:
        return ob
    else:
        return unicode_safe(ob, *args)

def unicode_safe(ob, *args):
    try:
        return unicode(ob, *args)
    except Exception, exc:
        prefix = report_error('unicode(ob)', exc)
        return prefix + u'repr: ' + unicode_repr_safe(ob)

def unicode_repr_safe(ob):
    try:
        r = repr(ob)
    except Exception, exc:
        return report_error('repr(ob)', exc)
    try:
        return unicode(r)
    except Exception, exc:
        return report_error('unicode(repr(ob))', exc)


def report_error(op, exc):
    return u'%s failed with %s; ' % (op, exc_repr_safe(exc))

def exc_repr_safe(exc):
    try:
        return unicode(exc)
    except:
        return '<unprintable error>'



